

from itertools import izip_longest, ifilter
import pprint

class SQL:

	def chunks(self,l, n):
		"""Yield successive n-sized chunks from l."""
		for i in xrange(0, len(l), n):
			yield l[i:i + n]

	def insertFromDict(self , table, d):
		"""Return SQL statement and data vector for insertion into table."""
		fields = []
		for k in d:
			fields.append( k )

		sql = 'INSERT OR IGNORE INTO %s (%s) VALUES(%s)' % ( table, ", ".join(fields), ", ".join("?" for f in fields))
		#if d["c"] > 2:
		#	print( sql, d.values() )
		return sql, d.values()


	def InsertInto_modular(self , connection , cursor , tablename , data , step=400):


		chunks = list( self.chunks( data , step) )

		for chunk in chunks:
			# connection.execute('BEGIN TRANSACTION')
			# for item in chunk:
			# print(item)
			args_str = ','.join(cursor.mogrify("%s", (x, )) for x in chunk)
			# sql = "INSERT INTO "+tablename+" (id, year,itemset) VALUES "+args_str+""
			sql = "INSERT INTO "+tablename+" (id, label) VALUES "+args_str+""
			# print(sql)

			try:
				cursor.execute(sql)
				# connection.commit()
			except Exception as e:
				# print e
				# print "FAIL:\t",chunk
				# print (" - - - - -  - - - - ")
				xxx=10
			# connection.execute('COMMIT TRANSACTION')
			connection.commit()
		results = [ tablename, "OK"]
		print "\t", results 
		# return results



