# pip install  simplejson  git+https://github.com/miguelgrinberg/Flask-Runner.git
# pip install biopython
#   more: https://flask-runner.readthedocs.io/en/latest/

# sudo su pksm3
# export SPARK_HOME="/opt/spark2"
# export PATH=$SPARK_HOME/bin:$PATH
# source env/bin/activate
# python phylum_srv.py -t 0.0.0.0 -p 8080

from flask import Flask, render_template, request , flash , jsonify , url_for, current_app
from flask.ext.runner import Runner #*#
import simplejson as json

from flask_wtf import Form
from wtforms import StringField, TextField, IntegerField, DecimalField, validators
from wtforms.validators import DataRequired
from flask_wtf.csrf import CsrfProtect
csrf = CsrfProtect()

import datetime
import pprint
from functools import wraps

app = Flask(__name__ , static_url_path='/static' )
app.secret_key = 's3cr3t'
csrf.init_app(app)
runner = Runner(app) #*#
from bigindex import LoadShit
import urllib

I = {}

def support_jsonp(f):
	"""Wraps JSONified output for JSONP"""
	@wraps(f)
	def decorated_function(*args, **kwargs):
		callback = request.args.get('callback', False)
		if callback:
			content = str(callback) + '(' + str(f().data) + ')'
			return current_app.response_class(content, mimetype='application/json')
		else:
			return f(*args, **kwargs)
	return decorated_function


# @csrf.exempt
# @app.route("/ngrams" , methods=("GET", "POST",))
# def test_post():
# 	pprint.pprint( request )
# 	if request.method == "POST":
# 		p_ = {}
# 		print( "did a POST" )
# 		for i in request.form:
# 			print( i , ":", request.form[i] )
# 			p_[i] = request.form[i]

# 		rr = {
# 			"hola": "mundo"
# 		}
# 		return json.dumps( rr )
# 		# return json.dumps( ["post","worked","mofos"] )

# 	return json.dumps( ["regular","get"] )
# 	# return jsonify( data=["normal","return"] )


@app.route('/test', methods=['GET'])
@support_jsonp
def test():
	return jsonify({"foo":"bar"})


runner.run()
