

function makeMiniGraph(className , w , h , b , rawdata, isStacked) {
    $("."+className+'_2').remove(); 
    
    var demo = document.getElementById(className);
    var div = document.createElement('div');
    div.className = className+'_2';
    div.style.display = 'inline-block';
    div.style.margin = '4px';
    demo.appendChild(div);
    $('<div id="'+className+'" style="width: 37%; height:6%; bottom: '+b+'%; position:absolute; left: 15%; right: 0; margin: 0 auto;" ></div>').insertAfter("#"+className)
    // rawdata.push( ["2015-03-01",Math.round(rawdata[0])] )
    // rawdata.pop()
    var the_data = rawdata.join("\n")

    g_mini = new Dygraph( div, the_data ,
        {
          width: w,
          height: h,
          showRoller: false,
          stackedGraph: isStacked,
          displayAnnotations: isStacked,
          highlightCircleSize: 1,
          strokeWidth: .7,
          strokeBorderWidth: .7,
          drawGrid:false,
          showLabelsOnHighlight:isStacked,
          labelsKMB:false,
          labelsKMG2:false,
          labelsUTC:false,
          drawAxis:false, // axis legends
          legend: "follow",

        }
    );
}



function doGraph(className, the_title, labels, donnes, isStacked) {
    var demo = document.getElementById(className);
    var div = document.createElement('div');
    $("#"+className).html("")
    div.className = className;
    div.style.display = 'inline-block';
    div.style.margin = '4px';
    demo.appendChild(div);
    console.log( "HAAAHAJAJH" )
    console.log( donnes )
    var the_data = donnes.join("\n")

    // var ngrams_chart_W = $("#rightish").width()*0.8;
    // var ngrams_chart_H = $("#rightish").height()*0.2;

    g = new Dygraph( div, the_data ,
        {
          width: 400, //ngrams_chart_W,
          height: 400, //ngrams_chart_H,
          // rollPeriod: 7,
          // errorBars: true,
          title: "the_title",
          titleHeight: 20,
          labels: labels.slice(),
          // stackedGraph: false,
          animatedZooms: true,

          highlightCircleSize: 2,
          strokeWidth: 1,
          // strokeBorderWidth: isStacked ,

          highlightSeriesOpts: {
            strokeWidth: 3,
            strokeBorderWidth: 1,
            highlightCircleSize: 5
          },
          showRangeSelector: false,
          showInRangeSelector: false,

          // // clickCallback: function(e, x, pts) {
          // //   console.log( "Click: " + pts_info(e,x,pts));
          // // },

          // pointClickCallback: function(e, p) {
          //   console.log( "Point Click: " + p.name + ": " + p.yval_stacked );
          //   console.log(p)
          // },

          // // zoomCallback: function(minX, maxX, yRanges) {
          // //   console.log( "Zoom: [" + minX + ", " + maxX + ", [" + yRanges + "]]");
          // // },

          // // drawCallback: function(g) {
          // //   console.log( "Draw: [" + g.xAxisRange() + "]");
          // // }
        }
    );

    // g.setSelection(false, 's005');
    //console.log(g);
}



/* Open when someone clicks on the span element */
function openNav() {
    // console.clear()
    document.getElementById("myNav").style.width = "100%";
}

/* Close when someone clicks on the "x" symbol inside the overlay */
function closeNav() {
    document.getElementById("myNav").style.width = "0%";
}


function dict_diff(obj1, obj2) {
    var result = {};
    $.each(obj1, function (key, value) {
        if (!obj2.hasOwnProperty(key) || obj2[key] !== obj1[key]) {
            result[key] = value;
        }
    });

    return result;
}






var K_i2s = {}
var K_oi2i = {}
// var K_s2i = {}
var loader_ = '<img width=20 src="/static/Phylo/libs/img2/loading-bar.gif"></img>'
var G = {
    "params_t0" : {},
}

var Clusters_2DEL = {}
var Terms_2DEL = {}

var POST_ = false

// "scontext"
// "from_"
// "to_"
// "elemfrequency"
// "minfpgsupp"
// "minfsetsize"
// "minsetdistance"
// "mram"
// "ncores"


function getParams(form , children_ ) {
    var p_ = {}
    $("#"+form).find( children_ ).each(function() {  
        p_ [ this.id ] = $(this).val()    
    });
    return p_;
}

$("#remove_terms").click( function(){


})

$("#remove_clusters").click( function(){
  console.log("removing clusteeeers")
  if (! $.isEmptyObject( selections )) {
    for(var cID in selections) {
      if( Nodes[cID].type=="Cluster" ) {
	      partialGraph.dropNode(cID)
	      try {
	        delete Nodes[cID]
	        delete dicts.nodes[cID]
	        delete dicts.D2N[cID]
	        delete Relations["1|1"][cID]
	      } catch(err) {
	        var xxxxx = 111
	      }
  	  }
    }
    partialGraph.refresh()
    partialGraph.draw()
  }
})

function send_params( D ) {

    var query = $("#pubmedquery").val().slice()
    query = encodeURIComponent( query )
    var count = $("#pubmed_scan-results").data( "count" )
    console.log( query +" : "+ count )
    D["query"] = query
    D["c"] = count
    $.ajax({
        type: 'POST',
        url: "/test",
        data: D ,
        dataType: 'json',
        success : function(data) {
            // console.clear()
            console.log( "EEEEHHH " )
            console.log( "EEEEHHH " )
            console.log( data )
            var toQuery = []

            if( data["phylojson"]["links"].length>0 ) {

              POST_ = data

              $("#pubmed_fetch-results").html( "<i>Perfect</i>" )

              for(var i in data["phylojson"]["nodes"]) {
                var noeud = data["phylojson"]["nodes"][i]
                // // here noeud.label is Integer
                if( noeud.type=="mesh_term" && !(noeud.label in K_i2s)  ) {
                  toQuery.push( noeud.label )
                }
              }

              if(toQuery.length>0)
                get_ngrams( toQuery )
              
              MainFunction_new( data["phylojson"] )
              closeNav()
            } else {
              $("#pubmed_fetch-results").html( "<i>No results</i>" )
            }
        },
        error: function(jqxhr,textStatus,errorThrown) {
            console.log(jqxhr);
            console.log(textStatus);
            console.log(errorThrown);
            console.log('PROBLEM: ajax in #send_params").bind(click)');
        }
    });
    return false;
}

$("#pubmed_fetch").bind('click', function() {
      
    console.log( "pubmed_fetch" )

    var URL = "<URL>"

    var params = { 
    	"a":"some", 
    	"b": "parameter" 
    }

    var count = $("#pubmed_scan-results").data( "count" )
    var query = $("#pubmedquery").val()
    if(query=="" || count==0)
        return false

    $("#pubmed_fetch-results").html(loader_)
    
    if ($.isEmptyObject(G["params_t0"])) {

        console.log( "params_t0   empty()" )
        G["params_t0"] = getParams("phyloform" , "input")
        return send_params( G["params_t0"] )

    } else {

        var params_t1 = getParams("phyloform" , "input")
        var params_diff = dict_diff( params_t1 , G["params_t0"] )

        console.log("")
        console.log("")
        console.log("")
        console.log("DIFF TIMES!!!")
        console.log( params_t1 )
        console.log( G["params_t0"] )
        console.log(" - - - - - - - ")
        console.log( params_diff )

        console.log("")
        console.log("")
        console.log("")
        // spark context has changed ->  change everything
        if("query" in params_diff) {
          return send_params( params_t1 )
        }

        if ( ! $.isEmptyObject(params_diff) ) {
            var params_cp = $.extend({}, params_diff);
            delete params_cp["mram"]
            delete params_cp["ncores"]
            if ( ! $.isEmptyObject(params_cp)) {
                console.log( "there is a difference" )
                console.log( params_diff )
                params_diff["scontext"] = params_t1["scontext"]
                G["params_t0"] = params_t1
                return send_params( params_diff )
            }
        }
    }
    
});
function pubmed_fetch( Q , count) {

    $.ajax({
        type: 'POST',
        url: "/search",
        data: Q ,
        dataType: 'json',
        success : function(data){ 
            console.log( "EEEEHHH " )
            console.log( data )

            // makeMiniGraph("pubmedquery_results" , 150 , 25 , 0 , ["Year,N", "1982,277604", "1983,291182", "1984,300404"], true)
        },
        error: function(jqxhr,textStatus,errorThrown) {
            console.log(jqxhr);
            console.log(textStatus);
            console.log(errorThrown);
            console.log('PROBLEM: ajax in #send_params").bind(click)');

        }
    });
    return false;
}


function pubmed_scan( query ) {
    $.ajax({
        url: 'http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esearch.fcgi',
        data: {
            db: 'pubmed',
            usehistory: 'y',
            term: query,
            retmode: 'json',
            retmax: 0
        },
        success : function(data) { 
            console.log( data.esearchresult )
            var count =  parseInt( data.esearchresult.count )
            console.log( "AAAAH "+count )
            $("#pubmed_scan-results").html( count+" hits." )
            $("#pubmed_scan-results").data( "count" , count )

        },
        error: function(jqxhr,textStatus,errorThrown) {
            console.log(jqxhr);
            console.log(textStatus);
            console.log(errorThrown);
            console.log('PROBLEM: ajax in #scan_pubmed").bind(click)');
            return false;
        }
    });
    return false;
}
$("#pubmed_scan").bind('click', function() {
    var query = $("#pubmedquery").val() 
    console.log( query )
    if(query!="") {
      $("#pubmed_scan-results").html(loader_)
      G["params_t0"] = {}
      pubmed_scan( query )
    }
    return false;
});


function get_ngrams( query ) {
    console.log( "get_ngrams!!" )
    console.log( query )
    var DD = { "elems": query}
    $.ajax({
        url: '/ngrams',
        type: 'POST',
        data: DD ,
        success : function(data) { 
            console.log( "get_ngrams!!" )
            // console.log( "data:" )
            // console.log( data )
            for(var i in data){
                K_i2s[ i ] = data[i]
            }
            // console.log( "K_i2s:" )
            // console.log( K_i2s )

            // console.log("iter mesh_terms")

            for(var i in dicts.nodes) {
              if( dicts.nodes[i].type=="mesh_term" ) {

                // console.log ( dicts.nodes[i]  )
                // console.log ( K_i2s[dicts.nodes[i].label]  )
                // console.log ( K_i2s[Number(dicts.nodes[i].label)]  )
                // console.log("")
                // console.log( dicts.nodes[i].label )
                // console.log( K_i2s[dicts.nodes[i].label] )
                var ID = dicts.nodes[i].id
                var newlabel = K_i2s[dicts.nodes[i].label]
                if( typeof( newlabel )!="undefined" ) {
                  K_oi2i [ newlabel ] = ID 
                  dicts.nodes[i].label = newlabel
                  Nodes[ ID ].label = newlabel

                }
              }
            }
            partialGraph.refresh()
            partialGraph.draw()


            labels = []
            for(var kk in K_i2s ){
                updateSearchLabels( kk , K_i2s[kk] , "mesh_term");
            }



        },
        error: function(jqxhr,textStatus,errorThrown) {
            console.log(jqxhr);
            console.log(textStatus);
            console.log(errorThrown);
            console.log('PROBLEM: ajax in #scan_pubmed").bind(click)');
            return false;
        }
    });
    return false;
}