#!/usr/bin/env python
# -*- coding: utf-8 -*-


import sys
import glob
import json
import pprint
from datetime import datetime
import time
import re
import json



INPUT     = "mesh.json"
# OUTPUT    = "folder"
if len(sys.argv)>1 and sys.argv[1]!=None: INPUT = sys.argv[1]
# if len(sys.argv)>2 and sys.argv[2]!=None: OUTPUT = sys.argv[2]


import psycopg2
conn = psycopg2.connect("dbname=meshfiltrd user=pksm3")
c = conn.cursor()

sql_commands = [
	"DROP TABLE IF EXISTS june2016;",
	"CREATE TABLE june2016( id INTEGER PRIMARY KEY , label VARCHAR(255) )",
]

for command in sql_commands:
	c.execute(  command )
	conn.commit()



f = open( INPUT , "r" )
K = json.load( f )
f.close()

DATA = []
DD = {}
C = 1
for ID in K:
	# if C==100: 
	# 	break


	if ID not in DD:
		DD[ID] = True
		DATA.append( (ID,K[ID],) )

	C += 1


print("")
print("inserting...",len(DATA))
from SQL import SQL
execc = SQL()
execc.InsertInto_modular( connection=conn , cursor=c , tablename="june2016" , data= DATA )



print("creating indexes...")
sql_indexes = [
	"CREATE INDEX label_idx ON june2016 (label);"
]
for command in sql_indexes:
	c.execute(  command )
	conn.commit()


conn.close()









# # # # CREATE INDEX # #
# # import psycopg2
# # conn = psycopg2.connect("dbname=pubmed user=pksm3")
# # c = conn.cursor()
# # print("creating indexes...")
# # sql_indexes = [
# # 	"CREATE INDEX year_idx ON publication (year);"
# # ]
# # for command in sql_indexes:
# # 	c.execute(  command )
# # 	conn.commit()
# # conn.close()